Rumor CodeForces - 893C

Vova promised himself that he would never play computer games... But recently Firestorm — a well-known game developing company — published their newest game, World of Farcraft, and it became really popular. Of course, Vova started playing it.

Now he tries to solve a quest. The task is to come to a settlement named Overcity and spread a rumor in it.

Vova knows that there are n characters in Overcity. Some characters are friends to each other, and they share information they got. Also Vova knows that he can bribe each character so he or she starts spreading the rumor; i-th character wants ci gold in exchange for spreading the rumor. When a character hears the rumor, he tells it to all his friends, and they start spreading the rumor to their friends (for free), and so on.

The quest is finished when all n characters know the rumor. What is the minimum amount of gold Vova needs to spend in order to finish the quest?

Take a look at the notes if you think you haven't understood the problem completely.

Input

The first line contains two integer numbers n and m (1 ≤ n ≤ 105, 0 ≤ m ≤ 105) — the number of characters in Overcity and the number of pairs of friends.

The second line contains n integer numbers ci (0 ≤ ci ≤ 109) — the amount of gold i-th character asks to start spreading the rumor.

Then m lines follow, each containing a pair of numbers (xi, yi) which represent that characters xi and yi are friends (1 ≤ xi, yi ≤ nxi ≠ yi). It is guaranteed that each pair is listed at most once.

Output

Print one number — the minimum amount of gold Vova has to spend in order to finish the quest.

Examples

Input

5 2
2 5 3 4 8
1 4
4 5

Output

10

Input

10 0
1 2 3 4 5 6 7 8 9 10

Output

55

Input

10 5
1 6 2 7 3 8 4 9 5 10
1 2
3 4
5 6
7 8
9 10

Output

15

Note

In the first example the best decision is to bribe the first character (he will spread the rumor to fourth character, and the fourth one will spread it to fifth). Also Vova has to bribe the second and the third characters, so they know the rumor.

In the second example Vova has to bribe everyone.

In the third example the optimal decision is to bribe the first, the third, the fifth, the seventh and the ninth characters.

#include <iostream>
using  namespace std;
#include<string>
#include<vector>
#pragma warning (disable:4996)
long long gold[1000000];
vector<int> rodes[1000000];
bool book[1000000];
long long ans, min_cur;
void bfs(long long a);
long long min(long long a, long long b) {
	return a < b ? a : b;
}
int main() {
	int n, m;
	cin >> n >> m;
	for (int cnt = 1; cnt <= n; cnt++)
		cin >> gold[cnt];
	for (int cnt = 0; cnt < m; cnt++) {
		int a, b;
		cin >> a >> b;
		rodes[a].push_back(b);
		rodes[b].push_back(a);
	}
	for (int cnt = 1; cnt <= n; cnt++) {
		if (!book[cnt]) {
			min_cur = gold[cnt];
			bfs(cnt);
			ans += min_cur;
		}
	}
	cout << ans;
}
void bfs(long long cnt) {
	if (!book[cnt]) {
		book[cnt] = true;
		min_cur = min(min_cur, gold[cnt]);
		for (int i : rodes[cnt]) {
			bfs(i);
		}
	}
}

这道题,是一个双向图,然后,可以通过数学关系得到,总的要花费的金额等于无链接的人加上有链接的人中花钱最少的(链接指的是朋友关系),也就是说,通过深度搜索(是dfs,不过我懒得改了)得到一条链接中的最小值,并给它做上标记,避免下次又访问到它,这就是大体 的思路

注意下,在主函数里写循环是因为深度搜索如果写找最小值的话,min的值会一直锁定为0,如果要写成一体的,最好要加个条件判断

然后这里算总花费的时候注意下要用long long ,因为每一个gold的值最大可能到2的九次方,那他们加起来就可以超过int 的范围,而int最多也就10次方出头而已

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

cjz-lxg

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值